package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.geom.Point;

	[SWF( frameRate="60" )]
	public class test_triangles extends Sprite
	{
		private var bitmapData: BitmapData;
		private var cpoints: Vector.<Vector.<Point>>;

		[Embed( source="assets/image2.jpg" )]
		private var img: Class;

		private var indices: Vector.<int>;
		private var points: Vector.<Vector.<Point>>;
		private var segments: int = 40;
		private var sprite: Sprite;
		private var uvdata: Vector.<Number>;
		private var vertex: Vector.<Number>;

		public function test_triangles()
		{
			addEventListener( Event.ADDED_TO_STAGE, onAddedToStage );
		}

		private function draw( e: Event = null ): void
		{
			vertex.length = 0;
			indices.length = 0;
			uvdata.length = 0;

			var k: int = 0;
			var mouse: Point = new Point( mouseX, mouseY );
			var npoint: Point;
			var pt: Point;

			for ( var x: int = 0; x < points.length; x++ )
			{

				for ( var y: int = 0; y < points[x].length; y++ )
				{
					pt = cpoints[x][y].clone();
					
					var uvx: Number = x / segments;
					var uvy: Number = y / segments;

					if ( y < segments )
						indices.push( k, k + segments + 1, k + 1, k + segments + 1, k + segments + 2, k + 1 );

					var lx: Number = pt.x - mouse.x;
					var ly: Number = pt.y - mouse.y;
					
					var myVar: Number = ( 50 / ( Math.sqrt( lx * lx + ly * ly )) * 200 );
					myVar = Math.min( 400,  Math.max( myVar, 0 ) );
					
					pt.x += ((( myVar - pt.x ) / 10 ) / 1.3);
					pt.y += ((( myVar - pt.y ) / 10 ) / 1.3);
					
					vertex.push( pt.x );
					vertex.push( pt.y );
					uvdata.push( uvx, uvy );
					++k;
				}
			}
			sprite.graphics.clear();
			sprite.graphics.beginBitmapFill( bitmapData, null, false, false );
			sprite.graphics.drawTriangles( vertex, indices, uvdata );
			sprite.graphics.endFill();
		}

		private function onAddedToStage( event: Event ): void
		{
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			this.x = this.y = 20;
			bitmapData = ( new img() as Bitmap ).bitmapData;
			addChild( sprite = new Sprite());
			test();
		}

		private function test(): void
		{
			points = new Vector.<Vector.<Point>>();
			cpoints = new Vector.<Vector.<Point>>();
			vertex = new Vector.<Number>();
			indices = new Vector.<int>();
			uvdata = new Vector.<Number>();

			for ( var x: int = 0; x < segments + 1; x++ )
			{
				points[x] = new Vector.<Point>();
				cpoints[x] = new Vector.<Point>();
				var px: Number = ( x / segments ) * bitmapData.width;

				for ( var y: int = 0; y < segments + 1; y++ )
				{
					var py: Number = ( y / segments ) * bitmapData.height;
					points[x][y] = new Point( px, py );
					cpoints[x][y] = points[x][y].clone();
				}
			}
			draw();
			addEventListener( Event.ENTER_FRAME, draw );
		}
	}
}